﻿using System;
using System.Collections.Generic;
using LerouxTechnologies.Services.Model;

namespace LerouxTechnologies.Services.DAL.Classes
{
    public sealed class Member : Services.Model.Member
    {
        public enum Roles
        {
            Admin,
            Member,
            Guest,
            Blocked
        }

        private Role Role;

        public Roles MemberRole
        {
            get 
            { 
                string roleName = Role.RoleName;
                foreach (Roles role in Enum.GetValues(typeof(Roles)))
                {
                    if (role.ToString() == roleName)
                    {
                        return role;
                    }

                }
                // If all else fail.
                return Roles.Blocked;
            }
            set { Role = Role.GetRole(value.ToString()); }
        }


        public Member() : base()
        {
            this.BirthDate = new DateTime();
            this.FirstName = "";
            this.LastName = "";
            this.MemberAddress = new MemberAddress();
            this.MemberId = 0;
            this.MessagesReceived = new List<Services.Model.Message>();
            this.MessagesSent = new List<Services.Model.Message>();
            this.Password = new Services.Model.Password();
            this.PasswordId = 0;
            Role = new Role();
            MemberRole = Roles.Blocked;
            this.Username = "";
            
        }


    }
}