﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using LerouxTechnologies.Services.Model;

namespace LerouxTechnologies.Services.DAL
{
    public class MembersService : IQueryable<Member>
    {
        lerouxtechnologiesEntities _db = new lerouxtechnologiesEntities();

        #region Implementation of IQueryable<Member>

        public void Create(Member item)
        {
            _db.Members.AddObject(item);

            _db.ObjectStateManager.ChangeObjectState(item, EntityState.Added);
            _db.SaveChanges();
        }

        public Member Retrieve(int id)
        {
            return _db.Members.Single(member => member.MemberId == id);
        }

        public void Update(Member item)
        {
            Member newMemberInfo = item;
            Member databaseMember = _db.Members.Single(member => member == item);

            databaseMember.BirthDate = item.BirthDate;
            databaseMember.FirstName = item.FirstName;
            databaseMember.LastName = item.LastName;
            databaseMember.MemberAddress = item.MemberAddress;
            databaseMember.MemberId = item.MemberId; // Iiishhhh
            databaseMember.MessagesReceived = item.MessagesReceived;
            databaseMember.MessagesSent = item.MessagesSent;
            databaseMember.Password = item.Password;
            databaseMember.PasswordId = item.PasswordId;
            databaseMember.Username = item.Username;

            _db.ObjectStateManager.ChangeObjectState(databaseMember, EntityState.Modified);
            _db.SaveChanges();
        }

        public void Delete(Member item)
        {
            _db.Members.DeleteObject(item);

            _db.ObjectStateManager.ChangeObjectState( item, EntityState.Deleted);
            _db.SaveChanges();
        }

        #endregion

        public Member Retrieve(string username)
        {
            return _db.Members.Single(member => member.Username == username);
        }

        public List<Member> GetMembersList()
        {
            return _db.Members.ToList();
        } 

    }
}